﻿using FlowerShopContracts.BindingModels;
using FlowerShopContracts.SearchModels;
using FlowerShopContracts.ViewModels;
using FlowerShopDataModels.Models;

namespace FlowerShopContracts.BusinessLogicsContracts
{
    public interface IShopLogic
    {
        ShopViewModel? ReadElement(ShopSearchModel model);
        List<ShopViewModel>? ReadList(ShopSearchModel? model);
        bool Create(ShopBindingModel model);
        bool Update(ShopBindingModel model);
        bool Delete(ShopBindingModel model);
        bool SupplyBouquets(ShopSearchModel model, IBouquetModel bouquet, int count);
        bool SellBouquet(IBouquetModel bouquet, int count);
    }
}
