﻿using FlowerShopDataModels.Models;
using System.ComponentModel;

namespace FlowerShopContracts.ViewModels
{
    public class ShopViewModel : IShopModel
    {
        public int Id { get; set; }

        [DisplayName("Название магазина")]
        public string Name { get; set; } = string.Empty;

        [DisplayName("Адрес")]
        public string Address { get; set; } = string.Empty;

        [DisplayName("Дата открытия")]
        public DateTime OpeningDate { get; set; }

        public Dictionary<int, (IBouquetModel, int)> ShopBouquets { get; set; } = new();

        [DisplayName("Макс. букетов в магазине")]
        public int MaxCountBouquets { get; set; }
    }
}
