﻿using FlowerShopContracts.BindingModels;
using FlowerShopContracts.ViewModels;
using FlowerShopDataModels.Models;

namespace FlowerShopListImplement.Models
{
    public class Bouquet : IBouquetModel
    {
        public int Id { get; private set; }
        public string BouquetName { get; private set; } = string.Empty;
        public double Price { get; private set; }
        public Dictionary<int, (IComponentModel, int)> BouquetComponents { get; private set; } = new Dictionary<int, (IComponentModel, int)>();

        public static Bouquet? Create(BouquetBindingModel? model)
        {
            if (model == null)
            {
                return null;
            }

            return new Bouquet()
            {
                Id = model.Id,
                BouquetName = model.BouquetName,
                Price = model.Price,
                BouquetComponents = model.BouquetComponents
            };
        }

        public void Update(BouquetBindingModel? model)
        {
            if (model == null)
            {
                return;
            }

            BouquetName = model.BouquetName;
            Price = model.Price;
            BouquetComponents = model.BouquetComponents;
        }

        public BouquetViewModel GetViewModel => new()
        {
            Id = Id,
            BouquetName = BouquetName,
            Price = Price,
            BouquetComponents = BouquetComponents
        };
    }
}
